
'--------------------------------------------------------------
' Tasten-programmierbare Steuerung TPS
' Test 1: Interpreter, die ersten drei Befehle
'--------------------------------------------------------------

$regfile = "m168def.dat"
$crystal = 11059200
$hwstack = 32
$swstack = 64
$framesize = 64


Dim Adr As Byte
Dim Eebyte As Byte
Dim Dat As Byte
Dim Kom As Byte

Ddrd = &HFF                                                 'D0...D1 Outputs
Portd = &H0F                                                'STK500 invertiert
Portc = &H0F                                                'C0..C3 Inputs mit Pullup

S1 Alias Pinc.3                                             'Dateneingabe
S2 Alias Pinc.0                                             'Programmieren

Waitms 200

Dat = &H11 : Writeeeprom Dat , 0                            'Dout=1
Dat = &H29 : Writeeeprom Dat , 1                            '1000 ms
Dat = &H18 : Writeeeprom Dat , 2                            'Dout=8
Dat = &H29 : Writeeeprom Dat , 3                            '1000 ms
Dat = &H34 : Writeeeprom Dat , 4                            'Adr = Adr - 4

Waitms 200

If S2 = 0 Then
  Goto Programmieren
Else
Ausfuehren:
  Adr = 0
  Do
    Readeeprom Eebyte , Adr
    Adr = Adr + 1
    Dat = Eebyte And 15
    Kom = Eebyte / 16
    If Kom = 1 Then                                         '1: Direkte Portausgabe
      Portd = 255 - Dat                                     'invertierte Portausgabe wegen STK500
    End If
    If Kom = 2 Then                                         '2: Wartezeit
      If Dat = 0 Then Waitms 1
      If Dat = 1 Then Waitms 2
      If Dat = 2 Then Waitms 5
      If Dat = 3 Then Waitms 10
      If Dat = 4 Then Waitms 20
      If Dat = 5 Then Waitms 50
      If Dat = 6 Then Waitms 100
      If Dat = 7 Then Waitms 200
      If Dat = 8 Then Waitms 500
      If Dat = 9 Then Waitms 1000
      If Dat = 10 Then Waitms 2000
      If Dat = 11 Then Waitms 5000
      If Dat = 12 Then Waitms 10000
      If Dat = 13 Then Waitms 20000
      If Dat = 14 Then Waitms 30000
      If Dat = 15 Then Waitms 60000
    End If
    If Kom = 3 Then                                         '3: Sprung - relativ
      Adr = Adr - 1
      Adr = Adr - Dat
    End If
  Loop
End If


Programmieren:
  Do
  Loop


End